<template>
  <AppModal
    v-if="showModal"
    :closing-cross="true"
    :no-default="true"
    class="preference-modal"
    @close="closeModal"
  >
    <template v-slot:body>
      <InformationsStep
        v-if="informationsStep"
        @get-step="getStep"
        @close="showModal = false"
      />
      <ShelvesStep
        v-if="shelvesStep"
        @get-step="getStep"
        @update-shelves="updateShelves"
        @display-modal="$emit('updateDisplayModal')"
        @close="showModal = false"
      />
      <GenresStep
        v-if="genresStep"
        :shelves="shelves"
        @get-step="getStep"
        @display-modal="$emit('updateDisplayModal')"
        @close="showModal = false"
      />
    </template>
  </AppModal>
</template>

<script>
import AppModal from '@/components/ui/AppModal'
import InformationsStep from '@/components/modals/preference/InformationsStep'
import GenresStep from '@/components/modals/preference/GenresStep'
import ShelvesStep from '@/components/modals/preference/ShelvesStep'

export default {
  name: 'PreferenceModal',
  components: { GenresStep, InformationsStep, ShelvesStep, AppModal },
  data() {
    return {
      showModal: true,
      informationsStep: true,
      shelvesStep: false,
      genresStep: false,
      shelves: []
    }
  },
  methods: {
    getStep(step) {
      switch (step) {
        case 'shelves-step':
          this.informationsStep = false
          this.shelvesStep = true
          this.genresStep = false
          break
        case 'genres-step':
          this.informationsStep = false
          this.shelvesStep = false
          this.genresStep = true
          break
        default:
          this.informationsStep = true
          this.shelvesStep = false
          this.genresStep = false
          break
      }
    },
    updateShelves(shelves) {
      this.shelves = shelves
    },
    closeModal() {
      this.$store.dispatch('hideCookieModal', 'preference')
      this.showModal = false
    }
  }
}
</script>

<style lang="scss">
.preference-modal {
  font-family: 'DINCond';

  h4 {
    font-family: 'DINCond-Bold';
  }
  .modal-header {
    display: none;
  }
  .modal-wrapper {
    width: 900px;
    @media (max-width: 768px) {
      padding: 0 1rem;
      min-width: inherit;
      width: 100%;
    }
  }

  .shelves-step,
  .genres-step {
    .list-dots {
      position: absolute;
      top: 10%;
      left: 45%;

      @include screen-size(lg) {
        position: relative;
        bottom: auto;
        margin-top: 28px;
      }

      li {
        width: 20px;
        height: 20px;
        background-color: $color-grey;
        display: inline-block;
        position: relative;
        cursor: pointer;
        margin-right: 12px;
        @include borderRadius(50%);
        @include transition(all 200ms ease);

        @include screen-size(lg) {
          width: 14px;
          height: 14px;
          margin-right: 6px;
        }

        &:last-child {
          margin-right: 0;
        }

        &.active,
        &:hover {
          &:before {
            content: '';
            display: block;
            position: absolute;
            width: 10px;
            height: 10px;
            background-color: $color-secondary;
            top: 50%;
            left: 50%;
            @include transform(translate(-50%, -50%));
            @include borderRadius(50%);

            @include screen-size(lg) {
              width: 6px;
              height: 6px;
            }
          }
        }
        &.no-hover {
          pointer-events: none;
        }
        button {
          visibility: hidden;
        }
      }
    }
  }
}
</style>
